module CRDB
 module Fake

  attr_accessor :fake_method_to_value_hash

  # Make a fake object. 
  #
  # A new object of the same class is created. 
  # Each method in the @@fake_method_to_value_hash array is called and 
  # and set to the value in that array. 
  def make_fake(*options_array)

    # Process options
    index = 0 
    if (options_array.length > 0)
      options_hash = options_array[0]
      if (options_hash.key?(:index))
        index = options_hash[:index]
      end
    end

    # 1. Get class name 
    class_name = self.class
    class_name.initialize_fake_method_to_value_hash()
    method_to_value_hash = class_name.new
    
    # 2. Create a new object of type class_name
    # fake = eval("#{class_name}.new")
    fake = class_name.new

    # 3. Get the method_to_value_hash for this class.
    method_to_value_hash = class_name.get_fake_method_to_value_hash()

    # 4. Call the methods
    method_to_value_hash.each do |method, values|
      fake.send(method + '=', values[index])
    end

    return fake
  end

 end # matches "module Fake"
end # matches "module CRDB"
